/* Copyright 2015, Michele Santullo
 * This file is part of DoorKeeper.
 *
 * DoorKeeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * DoorKeeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with DoorKeeper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef id6327FA76CFB44F65A459C69096EC65D5
#define id6327FA76CFB44F65A459C69096EC65D5

#include "doorkeeper.hpp"
#include <cstdint>

namespace dk {
	typedef Tyler<2>::coords coords2;
	typedef Tyler<2> Tyler2d;
	template <typename T> using Layer2d = Layer<T, 2>;
	typedef Viewport<2> Viewport2d;
	typedef BaseMapSource<2> BaseMapSource2d;
} //namespace dk

namespace dkh {
	template <uint32_t D, typename C>
	struct MapLoaderPool;

	template <typename C>
	using MapLoaderPool2d = MapLoaderPool<2, C>;
} //namespace dkh

#endif
