/* Copyright 2015, Michele Santullo
 * This file is part of DoorKeeper.
 *
 * DoorKeeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * DoorKeeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with DoorKeeper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef id583F11FE0934446E9135B4ADCFA1E4F9
#define id583F11FE0934446E9135B4ADCFA1E4F9

#include "implem/compatibility.h"
#include "implem/configuration.h"
#include "implem/vector.hpp"
#include <ciso646>
#include <cstdint>

namespace dk {
	template <typename T, uint32_t D>
	using VectorT = vwr::Vec<std::array<T, D>>;

	template <uint32_t D>
	using Vector = VectorT<CoordinateScalarType, D>;
} //namespace dk

#endif
